/*
 * words.c -- right now it just holds the stuff i wrote to replace
 * that beastie arg_number().  Eventually, i may move all of the
 * word functions out of ircaux and into here.  Now wouldnt that
 * be a beastie of a patch! Beastie! Beastie!
 *
 * Oh yea.  This file is copyrighted (C) 1994 by the beastie author.
 * Right now the only author is Jeremy "Beastie" Nelson. That may 
 * change pretty beastie soon.
 */

#include "irc.h"
#include "ircaux.h"

/*
 * search() looks for a character forward or backward from mark 
 *
 * This was broken before becuase i didnt think of what would happen
 * when you decremented the pointer and you were already going backwards.
 * *sigh* -- now this returns the character that its searching for, and 
 * the caller is responsible for moving off that character.
 */
char *search(start, mark, chars, how)
char *start;
char **mark;
char *chars;
int how;
{
        if (!mark || !*mark)
                *mark = start;

        if (how > 0)   /* forward search */
        {
		int counter = how;
		for (;counter > 0;counter--)
		{
                	*mark = sindex(*mark, chars);
			if (*mark && **mark)
				*mark += 1;
			else
				break;
		}
		if (*mark)
			*mark -= 1;
	}
	else if (how == 0)
		return (char *) 0;
	else  /* how < 0 */
	{
		int counter = how;
		for (;counter < 0;counter++)
		{
			*mark = rsindex(*mark, start, chars);
			if (*mark && **mark)
				*mark -= 1;
			else
				break;
		}
		if (*mark)
			*mark += 1;
	}
	return *mark;
}

char *move_up_word (word)
char *word;
{
	char *beastie;
	beastie = sindex(word, "^ \t\n");
	beastie = sindex(beastie, " \t\n");
	beastie = sindex(beastie, "^ \t\n");
	return beastie;
}

char *move_back_word (word)
char *word;
{
	char *beastie;
	beastie = rsindex(word, "^ \t\n");
	beastie = rsindex(beastie, " \t\n");
	return beastie;
}

/* Move to an absolute word number from start */
/* First word is always numbered zero. */
char *move_to_abs_word(start, mark, word)
char *start;
char **mark;
int word;
{
	char *pointer = start;
	int counter = word;

	for (;counter > 0 && *pointer;counter--)
	{
		while (*pointer && !isspace(*pointer))
			pointer++;
		while (*pointer && isspace(*pointer))
			pointer++;
	}

	if (mark)
		*mark = pointer;
	return pointer;
}

/* Move a relative number of words from the present mark */
char *move_word_rel(start, mark, word)
char *start;
char **mark;
int word;
{
	char *pointer = *mark;
	int counter = word;
	char *end = start + strlen(start);

	if (end == start) 	/* null string, return it */
		return start;

	if (end == *mark)	/* just in case */
		mark--;

	if (counter > 0)
	{
		for (;counter > 0 && pointer;counter--)
		{
			while (*pointer && !isspace(*pointer))
				pointer++;
			while (*pointer && isspace(*pointer)) 
				pointer++;
		}
	}
	else if (counter == 0)
		pointer = *mark;
	else if (counter < 0)
	{
		for (;counter < 0 && pointer > start;counter++)
		{
			while (pointer >= start && isspace(*pointer))
				pointer--;
			while (pointer >= start && !isspace(*pointer))
				pointer--;
		}
		pointer++; /* bump up to the word we just passed */
	}

	if (mark)
		*mark = pointer;
	return pointer;
}

/* Much simpler, much less error prone way to extract words from a string.
 */
char *extract(start, firstword, lastword)
char *start;
int  firstword;
int  lastword;
{
	/* If firstword or lastword is negative, then
	   we take those values from the end of the string */
	char *mark;
	char *mark2;
	char *booya = (char *) 0;

	/* If the firstword is positive, move to that word */
	if (firstword >= 0)
		move_to_abs_word(start, &mark, firstword);

	/* Otherwise, move to the firstwords from the end */
	else
	{
		mark = start + strlen(start);
		mark = move_word_rel(start, &mark, firstword);
	}

	/* When we find the last word, we need to move to the 
           END of the word, so that word 3 to 3, would include
	   all of word 3, so we sindex to the space after the word
 	 */
	/* EOS is a #define meaning "end of string" */
	if (lastword == EOS)
		mark2 = start + strlen(start);
	else 
	{
		if (lastword >= 0)
			move_to_abs_word(start, &mark2, lastword+1);
		else
		{
			mark2 = start + strlen(start);
			move_word_rel(start, &mark2, lastword);
		}
		while (mark2 > start && isspace(mark2[-1]))
			mark2--;
	}

	/* If the end is before the string, then there is nothing
	 * to extract (this is perfectly legal, btw)
         */
	if (mark2 < mark)
		malloc_strcpy(&booya, empty_string);
	else
	{
		/* Otherwise, copy off the string we just isolated */ 
		char tmp;
		tmp = *mark2;
		*mark2 = '\0';
		malloc_strcpy(&booya, mark);
		*mark2 = tmp;
	}
	return booya;
}


